ipcalc.c(3)

NOME
ipcalc.c - fornece utilitários para manipular endereços de IP.

SINOPSIAS

#include <ctype.h>
#include <popt.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

  Defina
#define IPBITS (sizeof(unsigned long int) * 8)
o número de bits em um endereço de IP.
#define IPBYTES (sizeof(unsigned long int))
o número de bytes em um endereço de IP.

  Funções
unsigned long int prefix2mask (int prefix)
cria uma máscara de rede de um número especificado de bits.
int mask2prefix (unsigned long int mask)
calcula o número de bits que não estão mascarados por uma máscara de rede.
unsigned long int default_netmask (unsigned long int addr)
retorna a máscara de rede padrão (canonical) associada com endereço de IP especificado.
unsigned long int calc_broadcast (unsigned long int addr, int prefix)
calcula endereço de radiofusão dando um endereço de IP e um comprimento de prefixo.
unsigned long int calc_network (unsigned long int addr, int prefix)
calcula o endereço da rede para um prefixo e endereço especificados.
const char* get_hostname (unsigned long int addr)
retorna o nome do host associado com o endereço de IP especificado.
int main (int argc, const char **argv)
wrapper program for ipcalc functions.

DETAILED DESCRIPTION

provides utilities for manipulating IP addresses.

 ipcalc provides utilities and a front-end command line interface for manipulating IP addresses, and calculating various aspects of an ip address/netmask/network address/prefix/etc.

Functionality can be accessed from other languages from the library interface, documented here. To use ipcalc from the shell, read the ipcalc(1) manual page.

When passing parameters to the various functions, take note of whether they take host byte order or network byte order. Most take host byte order, and return host byte order, but there are some exceptions.

FUNCTION DOCUMENTATION

  unsigned long int calc_broadcast (unsigned long int addr, int prefix)

calculate broadcast address given an IP address and a prefix length.

Parameters:

addr
    an IP address in network byte order.

prefix
    a prefix length.

Returns:
the calculated broadcast address for the network, in network byte order.

  unsigned long int calc_network (unsigned long int addr, int prefix)

calculates the network address for a specified address and prefix.

Parameters:

addr
    an IP address, in network byte order

prefix
    the network prefix

Returns:
the base address of the network that addr is associated with, in network byte order.

  unsigned long int default_netmask (unsigned long int addr)

returns the default (canonical) netmask associated with specified IP address.

 When the Internet was originally set up, various ranges of IP addresses were segmented into three network classes: A, B, and C. This function will return a netmask that is associated with the IP address specified defining where it falls in the predefined classes.

Parameters:

addr
    an IP address in network byte order.

Returns:
a netmask in network byte order.

  const char * get_hostname (unsigned long int addr)

returns the hostname associated with the specified IP address.

Parameters:

addr
    an IP address to find a hostname for, in network byte order

Returns:
a hostname, or NULL if one cannot be determined. Hostname is stored in a static buffer that may disappear at any time, the caller should copy the data if it needs permanent storage.

  main (int argc, const char ** argv)

wrapper program for ipcalc functions.

 This is a wrapper program for the functions that the ipcalc library provides. It can be used from shell scripts or directly from the command line.

For more information, please see the ipcalc(1) man page.

  int mask2prefix (unsigned long int mask)

calculates the number of bits masked off by a netmask.

 This function calculates the significant bits in an IP address as specified by a netmask. See also prefix2mask.

Parameters:

mask
    is the netmask, specified as an unsigned long integer in network byte order.

Returns:
the number of significant bits.

  unsigned long int prefix2mask (int bits)

creates a netmask from a specified number of bits.

 This function converts a prefix length to a netmask. As CIDR (classless internet domain internet domain routing) has taken off, more an more IP addresses are being specified in the format address/prefix (i.e. 192.168.2.3/24, with a corresponding netmask 255.255.255.0). If you need to see what netmask corresponds to the prefix part of the address, this is the function. See also mask2prefix.

Parameters:

prefix
    is the number of bits to create a mask for.

Returns:
a network mask, in network byte order.

AUTHOR

Generated automatically by Doxygen for initscripts from the source code.